new;
library option,pgraph;
optionSet;

cls;

K = seqa(80,1,41);
nK = rows(K);

sigma = 0.20;
tau = 1/12;
r = 0.05;
S0 = 100;
V0 = 0.2^2; 
theta = V0; 
Kappa = 0.5; 
sigmaV = 0.25; 
lambda = 0;  

rho = seqa(-0.5,0.25,5);
nRho = rows(rho);

ImpVol = zeros(nK,nRho);

_int_order = 128;
_int_mtd = 2;

i = 1;
do until i > nRho;
  ImpVol[.,i] = EuropeanHeston_ImpVol(S0,K,tau,r,V0,kappa,theta,sigmaV,rho[i],lambda);
  i = i + 1;
endo;  

indx = FindIndex(K,S0);
ImpVol_ATM = ImpVol[indx,.];

BCC0 = BinaryBS(S0,K,ImpVol,tau,r,r);
BCC1 = BinaryBS(S0,K,ImpVol_ATM,tau,r,r);
BCC2 = zeros(nK,nRho);

i = 1;
do until i > nRho;
  BCC2[.,i] = BinaryHeston(S0,K,tau,r,V0,kappa,theta,sigmaV,rho[i],lambda);
  i = i + 1;
endo;  

graphset;
  begwind;
  window(2,2,0);

  _pnum = 2; _pnumht = 0.20; _paxht = 0.20; _pframe = 0; _plwidth = 10;
  _ptitlht = 0.20;
  xlabel("K");
  xtics(80,120,10,2);
  _pltype = 6|1|3|4|5;

  fonts("simplex simgrma");

  setwind(1);
    ytics(0.18,0.24,0.02,2);    
    title("\216Implied Volatility");
    xy(K,ImpVol);
  setwind(2);
    _plegstr = "\202r\201 = -0.75\000\202r\201 = 0.50\000\202r\201 = 0"\
               "\000\202r\201 = +0.50\000\202r\201 = +0.75";
    _plegctl = {2 6 5.25 3.25};
    ytics(0,1,0.25,2);
    title("\216Heston prices");
    xy(K,BCC2);
  setwind(3);
    _plegctl = 0;
    ytics(-10,10,5,2);
    title("\216Relative differences (in percent)\L\216Case of implied volatility \202S\201(\202t\201,K)");
    xy(K,100*(BCC2./BCC0-1));

  setwind(4);
    ytics(-10,10,5,2);
    title("\216Relative differences (in percent)\L\216Case of implied volatility \202S\201(\202t\201,S]0[)");
    xy(K,100*(BCC2./BCC1-1));

  endwind;