new;
library option,pgraph;
optionSet;

cls;

_option_type = "put";

S0 = 95;
K = seqa(90,1,21);
sigma = 0.20;
tau = 12/12;
b = 0.05;
r = 0.5;

p = 0.50;

proc binary_S0(x);
  retp(BinarySmiled(x,K,sigma,tau,b,r,p)); 
endp;

proc binary_Sigma(x);
  retp(BinarySmiled(S0,K,x,tau,b,r,p)); 
endp;

d1 = BinarySmiled_Delta(S0,K,sigma,tau,b,r,p); 
d2 = gradp(&binary_S0,S0); 

g1 = BinarySmiled_Gamma(S0,K,sigma,tau,b,r,p); 
g2 = _option_hessp(&binary_S0,S0,0); 

v1 = BinarySmiled_Vega(S0,K,sigma,tau,b,r,p); 
v2 = gradp(&binary_Sigma,sigma); 

graphset;
  begwind;
  makewind(9/2,6.855/2,0,6.855/2,1);
  makewind(9/2,6.855/2,9/2,6.855/2,1);
  makewind(9/2,6.855/2,9/3,0,1);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6|3; _pcolor = 9|12;
  _paxht = 0.25; _pnumht = 0.25; _ptitlht = 0.30;

  setwind(1);
    title("\216Delta");
    xy(K,d1~d2);

  setwind(2);
    title("\216Gamma");
    xy(K,g1~g2);

  setwind(3);
    title("\216Vega");
    xy(K,v1~v2);

  endwind;

