/*
**> Average of Best-Of in Time Across Assets
**
*/

new;
library option,pgraph;

cls;

let x0 = 100 100 100;            
let mu = 0.05 0.06 0.07;
let sigma = 0.15 0.25 0.20;

let rho = {1,
           0.5, 1,
           0.25, 0.15, 1};

rho = xpnd(rho); 

t = seqa(0,0.25,9);

Ns = 100000;
x = array_simulate_mGBM(x0,mu,sigma,rho,t,Ns);

Nx = rows(x0);
Nt = rows(t);
BestOf = zeros(Ns,Nx);

i = 1;
do until i > Nx;                           // for each asset
  data = mGBM_getAsset(x,i);
  r = data[.,2:Nt] ./ data[.,1:Nt-1] - 1;  // we compute the quaterly returns for the 2 years period
  BestOf[.,i] = maxc(r');                  // we compute the maximum of the quaterly returns
  i = i + 1;
endo;

// BestOf is a Ns x Nx matrix where BestOf(i,j) indicates the Best-Of the quaterly returns of the asset j for the simulation i

MeanBestOf = meanc(BestOf');  // Average of of Best-Of in Time Across Assets

graphset;
  call histp(MeanBestOf,25);
