new;
library option,pgraph;
optionSet;

seed = 12546;

proc procMu(t,x);
  retp(0.8*(0.10-x));
endp;

proc procSigma(t,x);
  retp(exp(-(t-5)^2/3).*x);
endp;

proc procGradSigma(t,x);
  retp(exp(-(t-5)^2/3));
endp;

t = qmc_Generate_t(0,10,501);  // You have to use a small time spacing, because we use the Euler Scheme and not an exact scheme

rndseed seed;
x1 = qmc_simulate_SDE(0.10,&procMu,&procSigma,t,1);

rndseed seed;
x2 = qmc_simulate_SDE_milstein(0.10,&procMu,&procSigma,0,t,1);

rndseed seed;
x3 = qmc_simulate_SDE_milstein(0.10,&procMu,&procSigma,&procGradSigma,t,1);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3; _plwidth = 10; _pframe = 0;
  title("\216Simulations of a time non-homogeneous stochastic process");
  xlabel("\216t"); ylabel("\216x(t)");
  xy(t,x1~x2~x3);

